#pragma once

#include <Horde3D.h>

/* http://www.gamedev.net/community/forums/topic.asp?topic_id=330742 */

namespace AngelCodeFont
{
  struct CharDescriptor
  {
  	// clean 16 bytes
  	float x, y;
  	float Width, Height;
  	float XOffset, YOffset;
  	float XAdvance;
  	float Page;

  	CharDescriptor() :
      x(0), y(0), Width(0), Height(0), XOffset(0), YOffset(0), XAdvance(0), Page(0) { }
  };

  struct Charset
  {
  	float LineHeight;
  	float Base;
  	float Width, Height;
  	float Pages;
  	CharDescriptor Chars[256];
  };

  bool parseFont(const char *filename, Charset *charsetdesc);

  void showText(const char *text, float x, float y,
 	              float colR, float colG, float colB,
                ResHandle fontMaterialRes, int layer,
                Charset *charset);
}
